#include <algorithm>
#include <cstdlib>

#include <wx/window.h>

#include "warpgrid.h"

BEGIN_EVENT_TABLE( WarpGrid, wxGrid )
    EVT_GRID_CELL_LEFT_CLICK( WarpGrid::OnLeftClick )
    EVT_GRID_CELL_LEFT_DCLICK( WarpGrid::OnLeftDClick )
    EVT_GRID_LABEL_LEFT_CLICK( WarpGrid::OnLabelLeftClick )
    EVT_GRID_LABEL_RIGHT_CLICK( WarpGrid::OnLabelRightClick )
    EVT_GRID_RANGE_SELECT( WarpGrid::OnGridRangeSelect )
END_EVENT_TABLE()


WarpGrid::WarpGrid (
    wxWindow *parent,
    int id,
    size_t rowNo,
    size_t colNo,
    int cellHeight,
    int cellWidth,
    bool verticalConstraint,
    bool horizontalConstraint ) :
        MonochromeGrid ( parent, id, rowNo, colNo,
            cellHeight, cellWidth, verticalConstraint, horizontalConstraint )
{
    SetColLabelSize ( 0 );
    SetRowLabelSize ( 0 );

    init();

}

void WarpGrid::getWarpKey ( std::string &key )
{
    //tbd correct size of keyLetter?
    char keyLetter [ 10 ];

    std::vector<size_t> warpVector;
    getPositionVector ( warpVector );
    size_t warpVectorSize = warpVector.size();
    for ( size_t i = 0; i < warpVectorSize; i++ )
    {
        sprintf ( keyLetter, "%d", warpVector.at ( i ) );
        key += keyLetter;
    }
}

void WarpGrid::setWarpKey ( const std::string &key )
{
    std::vector<size_t> warpVector;
    size_t keySize = key.size();
    for ( size_t i = 0; i < keySize; i++ )
    {
        warpVector.push_back ( atoi ( ( char * ) ( key.substr ( i, 1 ).c_str() ) ));
    }
    setPositionVector ( warpVector );
}

void WarpGrid::init()
{
    preset ( 0 );
    /*clearAll();

    BeginBatch();
    int rowCount = GetNumberRows();
    for ( int i = 0; i < rowCount; i++)
    {
        setValue ( true, i, i );
    }
    EndBatch();
    */
}

void WarpGrid::preset ( size_t choice )
{
    clearAll();
    size_t p1[] = { 4, 5, 6, 7, 0, 1, 2, 3 };
    size_t p2[] = { 3, 2, 1, 0, 7, 6, 5, 4 };

    size_t p3[] = { 1, 0, 3, 2, 5, 4, 7, 6 };
    size_t p4[] = { 0, 2, 1, 3, 4, 6, 5, 7 };

    size_t p5[] = { 0, 0, 1, 2, 5, 6, 7, 7 };
    size_t p6[] = { 7, 6, 5, 2, 3, 4, 1, 0 };

    size_t p7[] = { 0, 7, 1, 6, 2, 5, 3, 4 };
    size_t p8[] = { 3, 4, 2, 5, 1, 6, 0, 7 };

    std::vector<size_t *> presetVector;
    presetVector.push_back ( p1 );
    presetVector.push_back ( p2 );
    presetVector.push_back ( p3 );
    presetVector.push_back ( p4 );
    presetVector.push_back ( p5 );
    presetVector.push_back ( p6 );
    presetVector.push_back ( p7 );
    presetVector.push_back ( p8 );

    size_t len = 8;

    std::vector<size_t> positionVector;
    for ( size_t i = 0; i < len; i++ )
    {
       positionVector.push_back ( presetVector[choice][i] );
    }
    setPositionVector ( positionVector );
}


void WarpGrid::preset1()
{
   preset ( 0 );
}

void WarpGrid::preset2()
{
    preset ( 1 );
}

void WarpGrid::preset3()
{
    preset ( 2 );
}

void WarpGrid::preset4()
{
    preset ( 3 );
}

void WarpGrid::preset5()
{
    preset ( 4 );
}

void WarpGrid::preset6()
{
    preset ( 5 );
}

void WarpGrid::preset7()
{
    preset ( 6 );
}

void WarpGrid::preset8()
{
    preset ( 7 );
}


void WarpGrid::OnGridRangeSelect(wxGridRangeSelectEvent& event)
{}

void WarpGrid::OnLabelLeftClick ( wxGridEvent &e )
{}


void WarpGrid::OnLabelRightClick ( wxGridEvent &e )
{}

void WarpGrid::OnLeftClick ( wxGridEvent &e )
{}

void WarpGrid::OnLeftDClick ( wxGridEvent &e )
{}
